package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @author zhoutg
 * @Description: 类型枚举
 * @date 2018年10月11日 下午3:33:22
 */
public enum BaseRegulationTypeEnum implements KeyedNamed {

    equals(1, "等于术语本身"),
    compare(2, "存在比较"),
    regexChiefSymptom(3, "主诉现病史正则"),
    regexPast(4, "既往史正则");

    @Setter
    private int key;

    @Setter
    private String name;

    BaseRegulationTypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static BaseRegulationTypeEnum getEnum(int key) {
        for (BaseRegulationTypeEnum item : BaseRegulationTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static BaseRegulationTypeEnum getEnum(String value) {
        for (BaseRegulationTypeEnum item : BaseRegulationTypeEnum.values()) {
            if (item.getName().equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        BaseRegulationTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
